
; EXE t@C̏擾
;---------- ---------- ---------- ---------- ----------

	sdim rsc_name ,1024, 32
	rsc_name(0)="?","RT_CURSOR","RT_BITMAP","RT_ICON","RT_MENU","RT_DIALOG"
	rsc_name(6)="RT_STRING","RT_FONTDIR","RT_FONT","RT_ACCELERATOR","RT_RCDATA"
	rsc_name(11)="RT_MESSAGETABLE","RT_GROUP_CURSOR","?","RT_GROUP_ICON","?"
	rsc_name(16)="RT_VERSION","RT_DLGINCLUDE","?","RT_PLUGPLAY","RT_VXD"
	rsc_name(21)="RT_ANICURSOR","RT_ANIICON","RT_HTML","RT_MANIFEST"

	e_res2 = "" : repeat 10
		e_res2 += " "+wpeek(a, 40+cnt*2)
	loop
	off = lpeek(a, 60)

	; EXE t@C̃`FbN
	noteadd "IMAGE_DOS_HEADER \ (64 bytes)"
	noteext  0, 2, strf("    0x%04X", wpeek(a,  0)) + "Fe_magic(Magic number) (" + getname(a, 0, 2) +")"
	noteext -1, 2, strf("%10d", wpeek(a,  2)) + "Fe_cblp (Bytes on last page of file)"
	noteext -1, 2, strf("%10d", wpeek(a,  4)) + "Fe_cp (Pages in file)"
	noteext -1, 2, strf("%10d", wpeek(a,  6)) + "Fe_crlc (Relocations)"
	noteext -1, 2, strf("%10d", wpeek(a,  8)) + "Fe_cparhdr (Size of header in paragraphs)"
	noteext -1, 2, strf("%10d", wpeek(a, 10)) + "Fe_minalloc (Minimum extra paragraphs needed)"
	noteext -1, 2, strf("%10d", wpeek(a, 12)) + "Fe_maxalloc (Maximum extra paragraphs needed)"
	noteext -1, 2, strf("%10d", wpeek(a, 14)) + "Fe_ss (Initial (relative) SS value)"
	noteext -1, 2, strf("%10d", wpeek(a, 16)) + "Fe_sp (Initial SP value)"
	noteext -1, 2, strf("%10d", wpeek(a, 18)) + "Fe_csum (Checksum)"
	noteext -1, 2, strf("%10d", wpeek(a, 20)) + "Fe_ip (Initial IP value)"
	noteext -1, 2, strf("%10d", wpeek(a, 22)) + "Fe_cs (Initial (relative) CS value)"
	noteext -1, 2, strf("%10d", wpeek(a, 24)) + "Fe_lfarlc (File address of relocation table)"
	noteext -1, 2, strf("%10d", wpeek(a, 26)) + "Fe_ovno (Overlay number)"
	noteext -1, 8, strf("0x%016X", lpeek(a, 28)) + "Fe_res[4] (Reserved words)"
	noteext -1, 2, strf("%10d", wpeek(a, 36)) + "Fe_oemid (OEM identifier (for e_oeminfo))"
	noteext -1, 2, strf("%10d", wpeek(a, 38)) + "Fe_oeminfo (OEM information; e_oemid specific)"
	noteext -1,20, e_res2 + "Fe_res2[10] (Reserved words)"
	noteext -1, 4, strf("%10d", off) + "Fe_lfanew (File address of new exe header)\n"

	machine = wpeek(a, off+4)
	NumberOfSections = wpeek(a, off+6)
	characteristics = wpeek(a, off+22)
	SizeOfOptionalHeader = wpeek(a, off+20)

	machine_name = ""
	if( machine == 0x000 ): machine_name = "IMAGE_FILE_MACHINE_UNKNOWN F"
	if( machine == 0x14c ): machine_name = "IMAGE_FILE_MACHINE_I386 F"
	if( machine == 0x162 ): machine_name = "IMAGE_FILE_MACHINE_R3000 F"
	if( machine == 0x166 ): machine_name = "IMAGE_FILE_MACHINE_R4000 F"
	if( machine == 0x168 ): machine_name = "IMAGE_FILE_MACHINE_R10000 F"
	if( machine == 0x184 ): machine_name = "IMAGE_FILE_MACHINE_ALPHA F"
	if( machine == 0x268 ): machine_name = "IMAGE_FILE_MACHINE_M68K F"
	if( machine == 0x1f0 ): machine_name = "IMAGE_FILE_MACHINE_POWERPC F"
	if( machine == 0x1a2 ): machine_name = "IMAGE_FILE_MACHINE_SH3 F"
	if( machine == 0x1a6 ): machine_name = "IMAGE_FILE_MACHINE_SH4 F"
	if( machine == 0x1c0 ): machine_name = "IMAGE_FILE_MACHINE_ARM F"

	characteristics_name = ""
	if( characteristics & 0x0002 ): characteristics_name = "IMAGE_FILE_EXECUTABLE_IMAGE F"
	if( characteristics & 0x0004 ): characteristics_name = "IMAGE_FILE_LINE_NUMS_STRIPPED F"
	if( characteristics & 0x0008 ): characteristics_name = "IMAGE_FILE_LOCAL_SYMS_STRIPPED F"
	if( characteristics & 0x0100 ): characteristics_name = "IMAGE_FILE_32BIT_MACHINE F"
	if( characteristics & 0x2000 ): characteristics_name = "IMAGE_FILE_DLL F"

	signature = lpeek(a, off)
	noteadd "IMAGE_NT_HEADERS32\ (PEwb_)"
	noteext off, 4, strf("0x%08X", signature) + "FSignature" +" ("+ getname(a, off, 4) + ")"
	noteadd "IMAGE_FILE_HEADER\ (PEwb_̈ꕔ)"
	noteext -1, 2, strf("    0x%04X", machine) + "F"+ machine_name +"Machine"
	noteext -1, 2, strf("%10d", NumberOfSections) + "FNumberOfSections (ZNV)"
	noteext -1, 4, strf("%10d", lpeek(a, off+ 8)) + "FTimeDateStamp (EXEt@C쐬)"
	noteext -1, 4, strf("%10d", lpeek(a, off+12)) + "FPointerToSymbolTable (V{e[ũt@Cʒu)"
	noteext -1, 4, strf("%10d", lpeek(a, off+16)) + "FNumberOfSymbols (V{̐)"
	noteext -1, 2, strf("%10d", SizeOfOptionalHeader) + "FSizeOfOptionalHeader (IMAGE_OPTIONAL_HEADER32\̂̃TCY)"
	noteext -1, 2, strf("%10d", characteristics) + "F"+ characteristics_name +"Characteristics(t@C̑l)"
	noteadd ""
	off += 24

	NumberOfRvaAndSizes = lpeek(a, off+90)
	NumberOfRvaAndSizes_off = off+94

	noteadd "IMAGE_OPTIONAL_HEADER"
	noteadd "// WtB[h"
	noteext off, 2, strf("    0x%04X", wpeek(a, off)) + "FMagic"
	noteext  -1, 1, strf("%10d",  peek(a, off+ 2)) + "FMajorLinkerVersion"
	noteext  -1, 1, strf("%10d",  peek(a, off+ 3)) + "FMinorLinkerVersion"
	noteext  -1, 4, strf("%10d", lpeek(a, off+ 4)) + "FSizeOfCode (R[hZNṼTCY)"
	noteext  -1, 4, strf("%10d", lpeek(a, off+ 8)) + "FSizeOfInitializedData (ς̃f[^ZNṼTCY)"
	noteext  -1, 4, strf("%10d", lpeek(a, off+12)) + "FSizeOfUninitializedData (̃f[^ZNṼTCY)"
	noteext  -1, 4, strf("%10d", lpeek(a, off+16)) + "FAddressOfEntryPoint"
	noteadd "	R[hZNV̂ǂ̈ʒuvOJn̂̃Gg[|Cgi["
	noteadd "	Gg[|CǵAC[Wx[X̑΃ItZbgl"
	noteext  -1, 4, strf("%10d", lpeek(a, off+20)) + "FBaseOfCode ([h̃R[hZNVʒu)"
	noteext  -1, 4, strf("%10d", lpeek(a, off+24)) + "FBaseOfData ([h̃f[^ZNVʒu)"
	noteadd "// NT ŗLtB[h"
	noteext  -1, 4, strf("0x%08X", lpeek(a, off+28)) + "FImageBase"
	noteext  -1, 4, strf("%10d", lpeek(a, off+32)) +"FSectionAlignment"
	noteext  -1, 4, strf("%10d", lpeek(a, off+36)) +"FFileAlignment"
	noteext  -1, 2, strf("%10d", wpeek(a, off+38)) +"FMajorOperatingSystemVersion"
	noteext  -1, 2, strf("%10d", wpeek(a, off+40)) +"FMinorOperatingSystemVersion"
	noteext  -1, 2, strf("%10d", wpeek(a, off+42)) +"FMajorImageVersion"
	noteext  -1, 2, strf("%10d", wpeek(a, off+44)) +"FMinorImageVersion"
	noteext  -1, 2, strf("%10d", wpeek(a, off+46)) +"FMajorSubsystemVersion"
	noteext  -1, 2, strf("%10d", wpeek(a, off+48)) +"FMinorSubsystemVersion"
	noteext  -1, 4, strf("%10d", lpeek(a, off+50)) +"FWin32VersionValue"
	noteext  -1, 4, strf("%10d", lpeek(a, off+54)) +"FSizeOfImage"
	noteext  -1, 4, strf("%10d", lpeek(a, off+58)) +"FSizeOfHeaders"
	noteext  -1, 4, strf("%10d", lpeek(a, off+62)) +"FCheckSum"
	noteext  -1, 2, strf("%10d", wpeek(a, off+66)) +"FSubsystem"
	noteext  -1, 2, strf("%10d", wpeek(a, off+68)) +"FDllCharacteristics"
	noteext  -1, 4, strf("%10d", lpeek(a, off+70)) +"FSizeOfStackReserve"
	noteext  -1, 4, strf("%10d", lpeek(a, off+74)) +"FSizeOfStackCommit"
	noteext  -1, 4, strf("%10d", lpeek(a, off+78)) +"FSizeOfHeapReserve"
	noteext  -1, 4, strf("%10d", lpeek(a, off+82)) +"FSizeOfHeapCommit"
	noteext  -1, 4, strf("%10d", lpeek(a, off+86)) +"FLoaderFlagsF"
	noteext  -1, 4, strf("%10d", NumberOfRvaAndSizes) +"FNumberOfRvaAndSizes"
	noteadd "// f[^fBNg (" + NumberOfRvaAndSizes + ")"
	noteext  -1, 4, strf("%10d", lpeek(a, off+94)) +"FVirtualAddress" 
	noteext  -1, 4, strf("%10d", lpeek(a, off+98)) +"FSize"
	noteadd "// f[^fBNgȗ"
	noteadd ""
	off += SizeOfOptionalHeader

	if( NumberOfSections > 0 ){
	noteadd "IMAGE_SECTION_HEADER ( 40 bytes ~ "+ NumberOfSections + " )"
	repeat NumberOfSections
		if( getname(a, off, 8) == ".rsrc"){
			chk_off = off
			VirtualAddress = lpeek(a, off+12)
			SizeOfRawData = lpeek(a, off+16)
			PointerToRawData = lpeek(a, off+20)
		}
		noteext  off, 8, strf("%10s", getname(a, off, 8)) +"FName"
		noteext   -1, 4, strf("%10s", lpeek(a, off+8)) +"FPhysicalAddress & VirtualSize"
		noteext   -1, 4, strf("%10s", lpeek(a, off+12)) +"FVirtualAddress"
		noteext   -1, 4, strf("%10s", lpeek(a, off+16)) +"FSizeOfRawData"
		noteext   -1, 4, strf("%10s", lpeek(a, off+20)) +"FPointerToRawData"
		noteext   -1, 4, strf("%10s", lpeek(a, off+24)) +"FPointerToRelocations"
		noteext   -1, 4, strf("%10s", lpeek(a, off+28)) +"FPointerToLinenumbers"
		noteext   -1, 2, strf("%10s", lpeek(a, off+32)) +"FNumberOfRelocations"
		noteext   -1, 2, strf("%10s", lpeek(a, off+34)) +"FNumberOfLinenumbers"
		noteext   -1, 4, strf("%10s", lpeek(a, off+36)) +"FCharacteristics"
		noteadd ""
		off += 40
	loop
	}
	off = PointerToRawData

	NumberOfNamedEntries = wpeek(a, off+12)
	NumberOfIdEntries = wpeek(a, off+14)

	; \[Ẍʒu
	noteadd "[ .rsrc ] ̃\[Xf[^"
	noteadd "IMAGE_RESOURCE_DIRECTORY (16 bytes)"
	noteext off, 4, strf("%10s", lpeek(a, off)) +"FCharacteristics"
	noteext  -1, 4, strf("%10s", lpeek(a, off+4)) +"FTimeDateStamp"
	noteext  -1, 2, strf("%10s", wpeek(a, off+8)) +"FMajorVersion"
	noteext  -1, 2, strf("%10s", wpeek(a, off+10)) +"FMinorVersion"
	noteext  -1, 2, strf("%10s", NumberOfNamedEntries) +"FNumberOfNamedEntries"
	noteext  -1, 2, strf("%10s", NumberOfIdEntries) +"FNumberOfIdEntries"
	noteadd ""
	off += 16

	dim rsc_dir_e, 2 : dim res_num, 32

	if( NumberOfNamedEntries + NumberOfIdEntries > 0 ){
	noteadd "IMAGE_RESOURCE_DIRECTORY_ENTRY ( 8 bytes ~ "+( NumberOfNamedEntries + NumberOfIdEntries )+" )"
	repeat NumberOfNamedEntries + NumberOfIdEntries
		noteadd "=============================="
		memcpy rsc_dir_e, a, 8, 0, off
		//\[X̌^ID擾
		if rsc_dir_e(0)&0x80000000 {	//̏ꍇ
			bgn = (rsc_dir_e(0)&0x7fffffff) + PointerToRawData
			size = wpeek(a, bgn) : bgn += 2
			sdim string2, size*2
			sdim string, size*2
			memcpy string2, a, size*2, 0, bgn
			WideCharToMultiByte 0,0,varptr(string2),size,varptr(string),1024,0,0
			poke string,size,0
			noteext off, 4, strf("0x%08X", rsc_dir_e(0) ) + "F\[X̌^F" + string
		} else {				//l(ID)̏ꍇ
			if( rsc_dir_e(0) < 25 ){
				string = rsc_name(rsc_dir_e(0))
				noteext off, 4, strf("%10d", rsc_dir_e(0) ) + "F\[X̌^F" + string
				//ZNVe[ũItZbg擾
				res_num( rsc_dir_e(0) ) = (rsc_dir_e(1)&0x7fffffff) + PointerToRawData
			} else {
				string = "" + rsc_dir_e(0)
				noteext off, 4, strf("%10d", rsc_dir_e(0) ) + "F\[X̌^"
			}
		}
		noteext  -1, 4, strf("0x%08X", rsc_dir_e(1)) + "FOffsetToDataF" + string
		if( rsc_dir_e(1)&0x80000000 ){
			sec = (rsc_dir_e(1) & 0x7fffffff) + PointerToRawData
			noteadd "           : " + strf("%10d", sec) +"Fe[uf[^Offset"
			noteadd "------------------------------"
			noteext sec, 2, strf("%10d", wpeek(a, sec+12) ) + "FNumberOfNamedEntries"
			noteext  -1, 2, strf("%10d", wpeek(a, sec+14) ) + "FNumberOfIdEntries"
		}
		off += 8 : await 1
	loop
	}
	noteadd "=============================="

	repeat 15
		off = res_num( cnt ) : if( off == 0 ): continue
		NumberOfNamedEntries = wpeek(a, off+12)
		NumberOfIdEntries = wpeek(a, off+14)

		; \[Ẍʒu
		noteadd ""
		noteadd ""+ rsc_name( cnt ) +" IMAGE_RESOURCE_DIRECTORY (16 bytes)"
		noteext off, 4, strf("%10d", lpeek(a, off)) + "FCharacteristics"
		noteext  -1, 4, strf("%10d", lpeek(a, off+ 4)) + "FTimeDateStamp"
		noteext  -1, 2, strf("%10d", wpeek(a, off+ 8)) + "FMajorVersion"
		noteext  -1, 2, strf("%10d", wpeek(a, off+10)) + "FMinorVersion"
		noteext  -1, 2, strf("%10d", NumberOfNamedEntries) + "FNumberOfNamedEntries"
		noteext  -1, 2, strf("%10d", NumberOfIdEntries) + "FNumberOfIdEntries"
		noteadd ""
		off += 16 : chk = cnt

		repeat limit(NumberOfNamedEntries + NumberOfIdEntries, 1, 10)
			;noteadd "IMAGE_RESOURCE_DIRECTORY_ENTRY (8 bytes)"
			memcpy rsc_dir_e, a, 8, 0, off
				noteext off, 4, strf("%10d",   rsc_dir_e(0)) + "FID"
			if( rsc_dir_e(1)&0x80000000 ){	//e[uf[^L
				noteext  -1, 4, strf("0x%08X", rsc_dir_e(1)) + "FOffsetToData ("+(rsc_dir_e(1)&0x7fffffff) +")"
				sec = (rsc_dir_e(1)&0x7fffffff) + PointerToRawData + 20
				;noteadd ""+ rsc_name( chk ) +" IMAGE_RESOURCE_DATA_ENTRY"
				noteext sec, 4, strf("0x%08X", lpeek(a, sec)) + "FOffsetToData1"
				;noteext  -1, 4, "SizeF"+ lpeek(a, sec+4)
				;noteext  -1, 4, "CodePageF"+ lpeek(a, sec+8)
				;noteext  -1, 4, "ReservedF"+ lpeek(a, sec+12)
				sec = lpeek(a, sec) + PointerToRawData
				noteext sec, 4, strf("0x%08X", lpeek(a, sec)) + "FOffsetToData2"
				/*if( chk ==  3 ){
					sec = ( lpeek(a, sec) ) + PointerToRawData - VirtualAddress
					noteext sec, 2, strf("0x%04X", wpeek(a,sec  )) + "F" + wpeek(a, sec)
					noteext sec, 2, strf("0x%04X", wpeek(a,sec+2)) + "F" + wpeek(a, sec+2)
				}*/
				if( chk == 14 ){
					sec = ( lpeek(a, sec) ) + PointerToRawData - VirtualAddress
					icon_numb = wpeek(a, sec+4)
					noteext sec, 2, "\F" + wpeek(a, sec)
					noteext  -1, 2, "ACR\[X^CvF" + wpeek(a, sec+2)
					noteext  -1, 2, "ACR̐F" + icon_numb
					repeat icon_numb
						noteext sec + 18 + (cnt*14), 2, "No."+(cnt+1)+" ̃ACRԍF" + wpeek(a, sec + 18 + (cnt*14)) +" ("+ peek(a, sec + 6 + cnt*14) +"x"+ peek(a, sec + 7 + cnt*14)+"px) " + wpeek(a, sec + 12 + cnt*14) +"bits"
					loop
				}
			} else {
				noteext  -1, 4, strf("0x%08X", rsc_dir_e(1)) + "FOffsetToData"
			}
			noteadd ""
			off += 8
		loop
	loop
