
#include "user32.as"
#include "kernel32.as"

ImageName = "NONE", "BMP", "ICON", "GIF", "JPEG", "PNG","MAG","PSD","EXE"

#ifdef __hsp30__
#ifndef __SHELL32__
#define global __SHELL32__
#uselib "SHELL32.DLL"
	#func global DragAcceptFiles "DragAcceptFiles" sptr,sptr
	#func global DragQueryFile "DragQueryFile" sptr,sptr,sptr,sptr
	#func global DragFinish "DragFinish" sptr
#endif
#endif

#ifndef WM_DROPFILES
	#define global WM_DROPFILES     0x0233
#endif

#define global WM_SETFOCUS    0x0007 ;tH[JXݒ
#define global WM_KILLFOCUS   0x0008 ;tH[JXO
#define global EM_SETSEL      0x00B1
#define global EM_SETREADONLY 0x00CF ;IuWFNgDFɂ
#define global WM_COPY        0x0301


#define global objgray(%1,%2=1) sendmsg objinfo(%1, 2), EM_SETREADONLY, %2, 0
#define global objnosel(%1) sendmsg objinfo(%1, 2), WM_KILLFOCUS,  0, 0
#define global inputsel(%1,%2=0,%3=-1) sendmsg objinfo(%1, 2), EM_SETSEL, %2, %3
#define global inputcopy(%1) sendmsg objinfo(%1, 2), WM_COPY

#enum global STD_FILENEW = 0 ;VK쐬
#enum global STD_FILEOPEN  ;J
#enum global STD_FILESAVE  ;ۑ
#enum global STD_BIG       ;+1
#enum global STD_SMALL     ;-1
#enum global STD_DEFAULT   ;1pxTCY
#enum global STD_FIT       ;tBbgTCY

#define global imgbutton(%1,%2) objimage WinMenu, 23*%1,0, 23*%1,24, 23*%1,24 : button gosub "", %2
#undef strmid
#undef peek


/*#ifdef _debug
#undef stop
#define stop assert : stop@hsp
#endif*/

;---------- ---------- ---------- ---------- ----------
; hbOhbvݒ
;---------- ---------- ---------- ---------- ----------
#define ondrop(%1,%2=hwnd) oncmd %1, WM_DROPFILES : DragAcceptFiles %2, 1

#module
;---------- ---------- ---------- ---------- ----------
; hbOhbv (t@C擾)
;---------- ---------- ---------- ---------- ----------
#deffunc getDropFile var list

	hdrop = wparam
	DragQueryFile hdrop, -1, 0, 0
	DragQueryFile hdrop, 0, varptr(list), 260
	DragFinish hdrop
	return

;---------- ---------- ---------- ---------- ----------
; R}hC擾
;---------- ---------- ---------- ---------- ----------
#deffunc get_cmdline var buf

	sdim tmp  ,260     : csize = strlen(dir_cmdline)
	sdim cline,csize+1 : cline = dir_cmdline

	notesel buf : i = 0
	repeat csize
		if i >= csize : break

		//t@C擾
		if peek(cline,i) == '"' {
			getstr tmp,cline,i+1,'"' : i+=strsize+2
		} else {
			getstr tmp,cline,i  ,' ' : i+=strsize
		}

		//Zt@C𐳏ɕϊ
		#ifdef GetLongPathName
			GetLongPathName varptr(tmp),varptr(tmp),260
		#endif

		noteadd tmp
	loop
	noteunsel
	return

;--------------------------------------
; ACRE_CAO
;--------------------------------------
#deffunc icondialog str file

	;uSHPickIconDialogv֐̃|C^擾
	LoadLibrary "shell32.dll" : pdll = stat
	GetProcAddress pdll, 62 : proc = stat

	; OS̎&o[W擾
	 dim prm,148 : prm = 148 : GetVersionEx varptr(prm)

	; NTn̏ꍇ̓jR[hgp
	sdim tmp,1024 : icon_index = 0
	if( prm.4 == 2 ): cnvstow tmp, file : else : tmp = file

	;uSHPickIconDialogv֐s
	prm = hwnd, varptr(tmp), 0, varptr(icon_index)
	ans = callfunc( prm, proc, 4 )

	; ǂݍDLLJ
	FreeLibrary pdll

	if( ans != 1 ) : return -1
	return icon_index

;---------- ---------- ---------- ---------- ----------
; w肵ϐ̃TCY擾
;---------- ---------- ---------- ---------- ----------
#defcfunc peek var buf, int off
	if( off <      0 ): return -1
	dim _size : dupptr _size, varptr(buf)-16, 4
	if( off >= _size ): return -1
	return peek@hsp( buf, off )

;---------- ---------- ---------- ---------- ----------
; w肵TCỸrbg擾
;---------- ---------- ---------- ---------- ----------
#defcfunc bits int buf, int off, int size
	return ( buf>>off ) & ( (1<<size)-1 )

;---------- ---------- ---------- ---------- ----------
; QoCg擾 ( rbOGfBA )
;---------- ---------- ---------- ---------- ----------
#defcfunc speek var buf, int off
	return peek(buf,off)<<8 | peek(buf,off+1)

;---------- ---------- ---------- ---------- ----------
; SoCg擾 ( rbOGfBA )
;---------- ---------- ---------- ---------- ----------
#defcfunc dpeek var buf, int off
	ans = 0 : repeat 4,off : ans = ans<<8 | peek(buf,cnt) : loop
	return ans

;---------- ---------- ---------- ---------- ----------
; ̎擾
;---------- ---------- ---------- ---------- ----------
#defcfunc getname var buf, int off, int size
	sdim ans,size+1 : memcpy ans,buf,size,0,off : poke ans, size, 0
	if( size > 0 ){
		repeat size
			c = peek(ans,cnt) : if ( c = 0 ) : break
			if ( c < 32 )||( c > 126 ) : poke ans,cnt,'?' ; getstr̃G[΍
		loop
	}
	getstr ans,ans,0 : poke ans,strsize,0 ; strsizeɕTCY擾
	return ans

;---------- ---------- ---------- ---------- ----------
; ̎擾 [Latin-1]
;---------- ---------- ---------- ---------- ----------
#defcfunc getname_Latin1 var buf, int off, int size
	sdim ans,size+1 : memcpy ans,buf,size,0,off : getstr ans,ans,0
	poke ans,strsize,0
	repeat strsize
		c = peek(ans,cnt)
		if ( c = 0x0A ) : continue  ; s
		if ( c < 32 )||( c > 126 ) : poke ans,cnt,'?'
	loop
	return ans

;---------- ---------- ---------- ---------- ----------
; kꂽ̎擾
;---------- ---------- ---------- ---------- ----------
#defcfunc getname_comp var buf, int off, int size
	sdim ans,size+1 : memcpy ans,buf,size,0,off : getstr ans,ans,0
	poke ans,strsize,0

	memset ans,'?',strsize,0
	return ans

;---------- ---------- ---------- ---------- ----------
; noteadd ̊g
;---------- ---------- ---------- ---------- ----------
#deffunc noteext int off, int size, str buf

	if( off >= 0 ): offset = off
	if( size > 0 ){
		noteadd strf("%08X(%d): %s", offset, size, buf)
		offset += size
	} else {
		noteadd strf("%08X(-): %s", offset, buf)
	}
	return

;---------- ---------- ---------- ---------- ----------
#deffunc notesub str buf
	noteadd "\t" + buf
	return

;---------- ---------- ---------- ---------- ----------
#deffunc noteborder int off
	if( off == 1 ){
		noteadd "=============================="
	} else {
		noteadd "------------------------------"
	}
	return

;---------- ---------- ---------- ---------- ----------
; strmid C (Ȃ肭擾łȂ̂)
;---------- ---------- ---------- ---------- ----------
#defcfunc strmid var buf, int off, int size
	sdim ans, size+1 : memcpy ans, buf, size, 0, off
	return ans

;---------- ---------- ---------- ---------- ----------
; BASE64f[^̉
;---------- ---------- ---------- ---------- ----------
#deffunc BASE64toDATA var buf

	flag = 0 : len = 0 : i = 0 : b = 0
	flen = strlen(buf)
*@
	if( i >= flen ): goto *@f
	a = peek(buf, i) : i++
	if( a == 0x0D )||( a == 0x0A ): goto *@b
	if( a == 0 )||( a == '=' ): goto *@f
	if( a == '+' ): a = 62
	if( a == '/' ): a = 63
	if( a >= 'A' )&&( a <= 'Z' ){ a -= 65 } else {
	if( a >= 'a' )&&( a <= 'z' ){ a -= 71 } else {
	if( a >= '0' )&&( a <= '9' ){ a +=  4 }}}

	if( b <= 0 ): b = 6 : flag = a << 2 : goto *@b
	b -= 2
	poke buf, len, flag | ( a >> b ) : len++
	flag = a << ( 8 - b )
	goto *@b
*@
	poke buf, len, 0
	return len

;---------- ---------- ---------- ---------- ----------
; qEBhEɂ
;---------- ---------- ---------- ---------- ----------
#deffunc winParent int hID
	setParent hwnd, hID
	;SetWindowLong hwnd, -20, 0x0081 ;WS_EX_TOOLWINDOW|WS_EX_DLGMODALFRAME
	SetWindowLong hwnd, -16, 0x46000000 ; WS_CHILD|
	SetWindowPos hwnd, 0, 0, 0, 0, 0, $37 ; screen 0, bgscrp
	return

;---------- ---------- ---------- ---------- ----------
;  XN[o[g悤ɂ
;---------- ---------- ---------- ---------- ----------
#deffunc winScrollBar

	if( ginfo_sx <= ginfo_winx )&&( ginfo_sy <= ginfo_winy ){
		return
	}

oncmd gosub *SCROLL,   $114
oncmd gosub *SCROLL,   $115

	; WS_VSCROLL|WS_HSCROLL XN[o[ǉ
	GetWindowLongA hwnd, -16
	SetWindowLongA hwnd, -16, stat | $300000
	SetWindowPos hwnd, 0, 0, 0, 0, 0, $37 ; screen 0, bgscrp

 	;SB_HORZ(0) WXN[o[
	Sinfo = 28, 0x0007, 0, ginfo_sx, ginfo_winx, 0, 0
	SetScrollInfo hwnd, 0, varptr(Sinfo), 1

	;SB_VERT(1) WXN[o[
	Sinfo = 28, 0x0007, 0, ginfo_sy, ginfo_winy, 0, 0
	SetScrollInfo hwnd, 1, varptr(Sinfo), 1
	return 1

*SCROLL //XN[o[쎞̏
	sel = ginfo_sel : gsel ginfo_intid
	m = iparam=$115 : GetScrollInfo hwnd, m, varptr(Sinfo)
	Code= wParam &$ffff
	repeat 1
		if Code= 5 : Sinfo.5 = wParam>>16&$ffff : break ;SB_THUMBTRACK
		if Code= 0 : Sinfo.5--         : break ;SB_LINEUP
		if Code= 1 : Sinfo.5++         : break ;SB_LINEDOWN
		if Code= 2 : Sinfo.5-= Sinfo.4 : break ;SB_PAGEUP
		if Code= 3 : Sinfo.5+= Sinfo.4 : break ;SB_PAGEDOWN
		if Code= 6 : Sinfo.5 = Sinfo.2 : break ;SB_TOP
		if Code= 7 : Sinfo.5 = Sinfo.3 :       ;SB_BOTTOM
	loop
	SetScrollInfo hwnd, m, varptr(Sinfo), 1
	if m : groll ginfo_vx, Sinfo.5 :else: groll Sinfo.5, ginfo_vy
	gsel sel : return 1

#global
;-----------------------
